// Solution for Visual studio
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <iostream>

using namespace std;

const int MaxN  =  1001 ;
const int MaxM  =  20000 ;
const int MaxC  =  4 ;

const int White = 1, Black = 2, Gray = 3;

struct MatrStr
{
	int C, Num;
};

struct CompStr
{
	int C, a, b;
};

int N, M;
MatrStr Matr[MaxN][MaxN];
int LabelsComp[MaxN];
int TotalComp;
int CountC;
int Labels[MaxN];
bool Solution;
int LenAnswer;
int Answer[MaxM];

CompStr Comp[MaxN][MaxN][MaxC];

void InputData()
{
	int i, f, s, Color;
	FILE *InputFile = fopen( "input.txt", "r" ) ;
    fscanf( InputFile, "%i%i", &N, &M );
//	ifstream InputFile( "input.txt" );
//	InputFile >> N >> M ;
	for (i = 0; i <= N; i++)
		for (s = 0; s <= N; s++)
		{
			Matr[i][s].C = 0 ;
			Matr[i][s].Num = 0 ;
		}
	for (i = 0; i < M; i++)
	{
		fscanf( InputFile, "%i%i%i", &f, &s, &Color );
		//InputFile >> f >> s >> Color ;
		Matr[f][s].C = Color ;
		Matr[f][s].Num = i + 1 ;
		Matr[s][f].C = Color ;
		Matr[s][f].Num = i + 1 ;
	}
	fclose( InputFile );
	//InputFile.close();
	return;
}

void OutputData()
{
	int i;
	ofstream OutputFile( "output.txt" );
	if (Solution)
	{
		OutputFile << LenAnswer << "\n" ;
        for (i = 1; i <= LenAnswer - 1; i++)
			OutputFile << Answer[i] << " " ;
		OutputFile << Answer[LenAnswer] << "\n" ;
	}
	else
		OutputFile << "-1\n" ;
	OutputFile.close();
	return;
}

void Dfs( int CurV )
{
	int i;
	LabelsComp[CurV] = TotalComp ;
	for (i = 1; i <= N; i++)
		if (Matr[CurV][i].C == Gray && LabelsComp[i] == 0)
			{
				Matr[CurV][i].C = 0 ;
				Matr[i][CurV].C = 0 ;
				Dfs( i );
			}
	return;
}

void InitComp()
{
	int i, j, k;
	for (i = 0; i <= TotalComp; i++)
		for (j = 0; j <= TotalComp; j++)
			for (k = 0; k < MaxC; k++)
			{
				Comp[i][j][k].C = 0 ;
				Comp[i][j][k].a = 0 ;
                Comp[i][j][k].b = 0 ;
			}
	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++)
			if (Matr[i][j].C != Gray && Matr[i][j].C > 0 && LabelsComp[i] != LabelsComp[j])
			{
				Comp[LabelsComp[i]][LabelsComp[j]][Matr[i][j].C].C = 1 ;
				Comp[LabelsComp[i]][LabelsComp[j]][Matr[i][j].C].a = i ;
                Comp[LabelsComp[i]][LabelsComp[j]][Matr[i][j].C].b = j ;
			}
	return;
}

void DfsComp( int CurComp, int Color )
{
	int i, a, b;
	Labels[CurComp] = 1 ;
	CountC++;
	for (i = 1; i <= TotalComp; i++)
		if (Labels[i] == 0)
			if (Comp[CurComp][i][Color].C == 1)
			{
				a = Comp[CurComp][i][Color].a ;
				b = Comp[CurComp][i][Color].b ;
				Matr[a][b].C = 0 ;
				Matr[a][b].Num = 0 ;
				Matr[b][a].C = 0 ;
				Matr[b][a].Num = 0 ;
				DfsComp( i, Color );
			}
	return;
}

void NullLabels()
{
	int i;
	for (i = 0; i <= TotalComp; i++)
		Labels[i] = 0 ;
	return;
}

void QuickSort( int Left, int Right )
{
	int l = Left, r = Right;
	int Middle = Answer[(l + r)/2] ;
	while (l < r)
	{
		while (Answer[l] < Middle)
			l++;
		while (Answer[r] > Middle)
			r--;
		if (l <= r)
		{
			int Exch = Answer[l] ;
			Answer[l] = Answer[r] ;
			Answer[r] = Exch ;
			l++;
			r--;
		}
	}
	if (l < Right)
		QuickSort( l, Right );
	if (Left < r)
		QuickSort( Left, r );
	return;
}

void PrepareEdges()
{
	int i, j;
	LenAnswer = 0 ;
	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++)
			if (Matr[i][j].C != 0)
			{
				LenAnswer++;
				Answer[LenAnswer] = Matr[i][j].Num ;
                Matr[i][j].C = 0 ;
				Matr[i][j].Num = 0 ;
				Matr[j][i].C = 0 ;
				Matr[j][i].Num = 0 ;
			}
	QuickSort( 1, LenAnswer );
	return;
}

void SolveProblem()
{
    int i;
	TotalComp = 0;
	for (i = 0; i <= N; i++)
		LabelsComp[i] = 0 ;
	for (i = 1; i <= N; i++)
		if (LabelsComp[i] == 0)
		{
			TotalComp++;
			Dfs( i );
		}
	InitComp();
	Solution = true ;
	CountC = 0 ;
	NullLabels();
	DfsComp( 1, White );
	if (CountC != TotalComp)
		Solution = false ;
	CountC = 0 ;
	NullLabels();
	DfsComp( 1, Black );
	if (CountC != TotalComp)
		Solution = false ;
	if (Solution == true)
        PrepareEdges();
	return;
}

int main()
{
	InputData();

	SolveProblem();

	OutputData();

	return 0;
}

