#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <math.h>

const int MaxLen = 1000000 ;
const int MaxN = 1000000 ;

char Sieve[MaxN];
int Prime[MaxN];
int Power[MaxN];

int N;
int CountPrimes;

class BCD;

BCD *GlobalRes;

class BCD
{

public:

	int Len;
	int Mas[MaxLen];
	BCD();
	~BCD();

	void ZeroBCD();
	int GetLen();
	void SetValue( int Value );
	
	void Add( BCD *Bcd );
	void Sub( BCD *Bcd );
	void MultLong( BCD *Bcd );
	void MultShort( int Num );

	void CopyBCD( BCD *Bcd );
	void PrintBCD( FILE *OutputFile );
};

void BCD::ZeroBCD()
{
	int i;
	Len = 0 ;
	for (i = 0; i < MaxLen; i++)
		Mas[i] = 0 ;
}

BCD::BCD()
{
//	ZeroBCD();
}

BCD::~BCD()
{}

int BCD::GetLen()
{
	return Len;
}

void BCD::SetValue( int Value )
{
//	ZeroBCD();
	int i;
	Len = 0 ;
	Mas[Len] = Value ;
    Len++;
	for (i = 0; i < 15; i++)
		Mas[i+Len] = 0 ;
	return;
}

void BCD::Add( BCD *Bcd )
{
	int i;
	if (Bcd->Len > Len)
		Len = Bcd->Len ;
	for (i = 0; i < Len; i++)
		Mas[i] = Mas[i] + Bcd->Mas[i] ;
	for (i = 0; i < Len; i++)
		if (Mas[i] > 9)
		{
			Mas[i+1] = Mas[i+1] + Mas[i]/10 ;
			Mas[i] = Mas[i] % 10 ;
		}
	while (Mas[Len] > 0)
	{
		Mas[Len+1] = Mas[Len+1] + Mas[Len]/10 ;
		Mas[Len] = Mas[Len] % 10 ;
		Len++;
	}
	return;
}

void BCD::Sub( BCD *Bcd )
{
	int i;
    for (i = 0; i < Len; i++)
		Mas[i] = Mas[i] - Bcd->Mas[i] ;
	for (i = 0; i < Len; i++)
		if (Mas[i] < 0)
		{
			Mas[i] = Mas[i] + 10 ;
			Mas[i+1]--;
		}
	while (Len - 1 >= 0 && Mas[Len-1] == 0)
		Len--;
	return;
}

void BCD::MultShort( int Num )
{
	int i;
    for (i = 0; i < 15; i++)
		Mas[Len+i] = 0 ;
	for (i = 0; i < Len; i++)
		Mas[i] = Mas[i]*Num ;
	for (i = 0; i < Len; i++)
		if (Mas[i] > 9)
		{
			Mas[i+1] = Mas[i+1] + Mas[i]/10 ;
			Mas[i] = Mas[i] % 10 ;
		}
	while (Mas[Len] > 0)
	{
		Mas[Len+1] = Mas[Len+1] + Mas[Len]/10 ;
		Mas[Len] = Mas[Len] % 10 ;
		Len++;
	}
	while (Len - 1 >= 0 && Mas[Len - 1] == 0)
		Len--;
	return;
}

void BCD::CopyBCD( BCD *Bcd )
{
	int i;
	Len = Bcd->Len ;
	for (i = 0; i < MaxLen; i++)
		Mas[i] = Bcd->Mas[i] ;
	return;
}

void BCD::MultLong( BCD *Bcd )
{
	int i, j;
	BCD *Res;
	Res = new BCD() ;

	Res->Len = Len + Bcd->Len ;
	for (i = 0; i <= Res->Len+15; i++)
		Res->Mas[i] = 0 ;

    for (i = 0; i < Len; i++)
		for (j = 0; j < Bcd->Len; j++)
			Res->Mas[i+j] = Res->Mas[i+j] + Mas[i]*Bcd->Mas[j] ;

	for (i = 0; i < Res->Len; i++)
		if (Res->Mas[i] > 9)
		{
			Res->Mas[i+1] = Res->Mas[i+1] + Res->Mas[i]/10 ;
			Res->Mas[i] = Res->Mas[i] % 10 ;
		}
	while (Res->Mas[Res->Len] > 0)
	{
		Res->Mas[Res->Len+1] = Res->Mas[Res->Len+1] + Res->Mas[Res->Len]/10 ;
		Res->Mas[Res->Len] = Res->Mas[Res->Len] % 10 ;
		Res->Len++;
	}

	while (Res->Len - 1 >= 0 && Res->Mas[Res->Len - 1] == 0)
		Res->Len--;

	Len = Res->Len ;
	//CopyBCD( Res );
	for (i = 0; i <= Res->Len+15; i++)
		Mas[i] = Res->Mas[i] ;

	delete Res;
	return;
}

void BCD::PrintBCD( FILE *OutputFile )
{
	int i;
	for (i = Len - 1; i >= 0; i--)
		fprintf( OutputFile, "%i" , Mas[i] );
	fprintf( OutputFile, "\n" );
	return;
}

void InputData()
{
	FILE *InputFile;
	InputFile = fopen( "input.txt", "r" ) ;
	fscanf( InputFile, "%i", &N );
	fclose( InputFile );
	return;
}

void OutputData()
{
	FILE *OutputFile;
	OutputFile = fopen( "output.txt", "w" ) ;
	GlobalRes->PrintBCD( OutputFile );
	fclose( OutputFile );
	return;
}

void Eratosphene( int N )
{
	int i, j;
	for (i = 0; i < MaxN; i++)
		Sieve[i] = 0 ;
	for (i = 2; i <= N ; i++)
		if (Sieve[i] == 0)
		{
			j = i*2 ;
			while (j <= N)
			{
				Sieve[j] = 1 ;
				j = j + i ;
			}
			Prime[CountPrimes] = i ;
			CountPrimes++;
		}
	return;
}

void Factorisation( int N )
{
    int i, j;
	for (i = 0; i < CountPrimes; i++)
	{
		j = Prime[i] ;
		Power[i] = 0 ;
		while (j <= N)
		{
            Power[i] = Power[i] + N/j ;
			j = j*Prime[i] ;
		}
	}
	return;
}

void GetPower( BCD *Bcd, int Number, int ReqPower )
{
	int i;
	for (i = 1; i <= ReqPower; i++)
		Bcd->MultShort( Number );
	return;
}

void LongMult( BCD *A, BCD *B, BCD *C )
{
	int i, j;

	C->Len = A->Len + B->Len + 1 ;
	for (i = 0; i <= C->Len + 15; i++)
		C->Mas[i] = 0 ;

	for (i = 0; i < A->Len; i++)
		for (j = 0; j < B->Len; j++)
			C->Mas[i+j] = C->Mas[i+j] + A->Mas[i]*B->Mas[j] ;

	for (i = 0; i < C->Len; i++)
		if (C->Mas[i] > 9)
		{
			C->Mas[i+1] += C->Mas[i]/10 ;
			C->Mas[i] %= 10 ;
		}

	while (C->Mas[C->Len] > 0)
	{
		C->Mas[C->Len+1] += C->Mas[C->Len]/10 ;
		C->Mas[C->Len] %= 10 ;
	}

	while (C->Len - 1 >= 0 && C->Mas[C->Len - 1] == 0)
		C->Len--;

	return;
}

void BCDWork()
{
	int i, j;
	BCD *Bcd1;
	BCD *Bcd2;
	BCD *Mult;
	Bcd1 = new BCD() ;
	Bcd2 = new BCD() ;
	Mult = new BCD() ;
	GlobalRes = new BCD() ;
	GlobalRes->SetValue( 1 );
	for (i = 0; i < CountPrimes; i++)
	{
		Bcd1->SetValue( 1 );
		Bcd2->SetValue( 1 );
		GetPower( Bcd1, Prime[i], Power[i] );
		GetPower( Bcd2, Prime[i], Power[i] - 1 );
		Bcd1->Sub( Bcd2 );
		//GlobalRes->MultLong( Bcd1 );
        LongMult( GlobalRes, Bcd1, Mult );
		GlobalRes->Len = Mult->Len ;
        for (j = 0; j <= Mult->Len + 15; j++)
			GlobalRes->Mas[j] = Mult->Mas[j] ;
	}
	return;
}

void SolveProblem()
{
	Eratosphene( N );
    Factorisation( N );
    BCDWork();
	return;
}

int main()
{
	InputData();

	SolveProblem();

	OutputData();
    
	return 0;
}
