#include <stdio.h>
#include <memory.h>

const int size = 80000;

class BCD 
{
public:
	int n;
	int a[size];

	BCD() {
		memset(a, 0, sizeof(a));
		n=0;
	}

	void null()	{
		for (int i=0;i<=n;++i) a[i]=0;
		n=0;
	}

	void operator+=(const BCD &q)	{
		int i,m=n;
		
		if (q.n>m) m=q.n;

		for (i=1;i<=q.n;++i) 
		{
			a[i]+=q.a[i];

			if (a[i]>9)
			{
				a[i]-=10;
				++a[i+1];
			}
		}

		i = q.n+1;

		while (a[i]>9)
		{
			a[i]-=10;
			++a[1+i++];
		}

		if (a[i]==0) --i;
		if (i>n) n=i;
	}

	void operator -=(const BCD &q) {
		int i;

		for (i=1;i<=q.n;++i)
		{
			a[i]-=q.a[i];
			if (a[i]<0)
			{
				--a[i+1];
				a[i]+=10;
			}
		}

		i=q.n+1;

		while (a[i]<0)
		{
			--a[i+1];
			a[i]+=10;
		}

		while (a[n]==0 && n>0) --n;
	}

	void operator *=(int q)	{
		int i;

		for (i=1;i<=n;++i) a[i]*=q;
		
		for (i=1;i<=n;++i)
			if (a[i]>9)
			{
				a[i+1]+=(a[i]/10);
				a[i]%=10;
			}

		i=n+1;

		while (a[i]>9)
		{
			a[i+1]=a[i]/10;
			a[i++]%=10;
		}

		if (i>n) n=i;

		while (a[n]==0 && n>0) --n;
	}

	void operator /=(int q)	{
		int delim=0,i;

		for (i=n;i>1 && delim<=q;--i) delim=delim*10+a[i];
		
		n=1+i++;
		
		while (i>0)
		{
			a[i]=delim/q;
			delim%=q;
			if (i>1) delim=delim*10+a[i-1];
			--i;
		}

		while (a[n]==0 && n>0) --n;
	}

	void operator = (int q)	{
		null();
		while (q!=0)
		{
			a[++n]=q%10;
			q/=10;
		}
	}

	void operator = (const BCD &q) {
		null();
		for (int i=1;i<=q.n;++i) a[i]=q.a[i];
		n=q.n;
	}
};

int n;
BCD a,b,c,d,e;
bool simple[30000];

void process() {
	memset(simple,true,sizeof(simple));
	int i,j;

	for (i=2;i<=n;++i)
		if (simple[i])
			for (j=2*i;j<=n;j+=i) simple[j]=false;
	a=1;

	for (i=2;i<=n;++i) a*=i;

	for (i=2;i<=n;++i)
		if (simple[i])
		{
			c=a;
			d=b;
			e=a;
			e/=i;
			d+=e;
			e=b;
			e/=i;
			c+=e;
			a=c;
			b=d;
		}
	a-=b;
}

void outdata() {
	FILE *f=fopen("output.txt","w");

	if (a.n==0) fprintf(f,"0");
		else 
	for (int i=a.n;i>=1;--i) fprintf(f,"%d",a.a[i]);

	fprintf(f,"\n");
	fclose(f);
}

int main() {
	FILE *fin=fopen("input.txt","r");
	fscanf(fin,"%d",&n);
	fclose(fin);

	process();

	FILE *fout=fopen("output.txt","w");

	if (a.n==0) fprintf(fout,"0");
		else 
	for (int i=a.n;i>=1;--i) fprintf(fout,"%d",a.a[i]);

	fprintf(fout,"\n");
	fclose(fout);
	
	return 0;
}